#include "StdAfx.h"

CLogger::CLogger(void) {
	m_ttStartTime = time(NULL);
}

CLogger::~CLogger(void) {
}

CLogger* CLogger::m_pInstance = NULL;
const int CLogger::L_ALL		= 16;
const int CLogger::L_DEBUG		=  8;
const int CLogger::L_INFO		=  4;
const int CLogger::L_WARNING	=  2;
const int CLogger::L_FATAL		=  1;
const int CLogger::L_NONE		=  0;

CLogger* CLogger::getInstance()
{
	if ( m_pInstance == NULL ) {
		// redirect STDOUT to file
		FILE *stream ;
		if ( (stream = freopen("stdout.txt", "w", stdout)) == NULL ) {
			exit(-1);
		}

		m_pInstance = new CLogger();
		m_pInstance->setLogLevel(L_ALL);
	}
	return m_pInstance;
}

void CLogger::setLogLevel(int level) {
	m_iLogLevel = level;
}

void CLogger::getCurrentTime(char* buffer) {
	time_t rawtime;
	struct tm * timeinfo;

	time(&rawtime);
	timeinfo = localtime(&rawtime);

	strftime(buffer, 80, "%Y-%m-%d %H:%M:%S", timeinfo);
}

void CLogger::info(char* message) {
	if ( m_iLogLevel >= L_INFO ) {
		char buffer [80];
		getCurrentTime(buffer);
		printf( "[INFO]  %s - %s", buffer, message );
		printf("\n");
	}
}

void CLogger::warning(char* message) {
	if ( m_iLogLevel >= L_WARNING ) {
		char buffer [80];
		getCurrentTime(buffer);
		printf( "[WARN]  %s - %s", buffer, message );
		printf("\n");
	}
}

void CLogger::fatal(char* message) {
	if ( m_iLogLevel >= L_FATAL ) {
		char buffer [80];
		getCurrentTime(buffer);
		printf( "[FATAL] %s - %s", buffer, message );
		printf("\n");
	}
}

void CLogger::debug(char* message) {
	if ( m_iLogLevel >= L_DEBUG ) {
		char buffer [80];
		getCurrentTime(buffer);
		printf( "[DEBUG] %s - %s", buffer, message );
		printf("\n");
	}
}