#pragma once
#include <stdio.h>
#include <time.h>

class CLogger
{
	public:
		static CLogger* getInstance();

		static const int L_ALL;
		static const int L_DEBUG;
		static const int L_INFO;
		static const int L_WARNING;
		static const int L_FATAL;
		static const int L_NONE;

		void setLogLevel(int);
		void info(char*);
		void warning(char*);
		void fatal(char*);
		void debug(char*);

	protected:
		CLogger(void);
		~CLogger(void);

	private:
		void getCurrentTime(char*);

		static CLogger *m_pInstance;
		int m_iLogLevel;
		time_t m_ttStartTime;
};