// OpenGL.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "OpenGL.h"

// COpenGL

IMPLEMENT_DYNCREATE(COpenGL, CFrameWnd)

COpenGL::COpenGL()
{
}

COpenGL::~COpenGL()
{
	// Hier beendet das OpenGL-Objekt sein Leben
	// Aktuellen Render Context holen
	HGLRC hglrc = wglGetCurrentContext();
	// Aktuellen Render Context deaktivieren
	wglMakeCurrent(NULL, NULL);
	// Render Context endgltig lschen
	wglDeleteContext(hglrc);
}


BEGIN_MESSAGE_MAP(COpenGL, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()	
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

// COpenGL-Meldungshandler

bool COpenGL::InitOpenGL(char* text, int x0, int y0, int x1, int y1)

{
// Initialisierung von OpenGL
// 1. OpenGL-Fenster als Typ "Child" definieren
	if (Create(
		NULL,
		text,
		WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_SIZEBOX   ,
		CRect(x0,y0,x1,y1),
		NULL,
		NULL,
		NULL, 
		NULL))
	{ // Create war erfolgreich,
		// 2. Rendering-Context initialisieren
		if (!SetRenderingContext())   // RC-DC Verbindung setzen
			return false;   // Melde: Fehler -> Abbruch
		// 3. Fenster anzeigen
		ShowWindow(SW_SHOWNOACTIVATE);
		// 4. hier weitere Initialisierungen ...
		
		
		return TRUE;  // Melde: Alles gut gegangen
	}
	
	return false;  // Melde: Hier ist was schief gelaufen
}

bool COpenGL::SetRenderingContext(void)
{
// In dieser Funktion wird der Render-Kontext RC mit dem
// Device-Kontext DC des OpenGL-Fensters verbunden
	PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
			1,
			PFD_DRAW_TO_WINDOW
			| PFD_DRAW_TO_BITMAP
			| PFD_SUPPORT_OPENGL
			| PFD_DOUBLEBUFFER   ,
			PFD_TYPE_RGBA,
			32,
			0,0,0,0,0,0,
			0,0,
			0,0,0,0,0,
			16,
			0,
			0,
			0,
			0,
			0,
			0,
			0
	};
	m_pcdc = GetDC();   // Lokalen Zeiger auf eigenen DC
	HDC hdc = m_pcdc->m_hDC; // Lokalen Handle auf eigenen DC
	int iPixelFormat = ChoosePixelFormat(hdc, &pfd); // Pixelformat auswhlen
	SetPixelFormat(    // Pixelformat setzen
		hdc,           // Handle auf DeviceContext
		iPixelFormat,  // Pixelformat mitteilen
		&pfd);         // Zeiger auf Struktur

	
	m_hglrc =      // Render Context fr OGL erzeugen
		wglCreateContext(hdc);  // ber DC-Handle
	if (m_hglrc == NULL) return false;  // Fehler -> Abbruch
	if (!wglMakeCurrent(  // akt. RC-DC Verbindung setzen
		m_pcdc->GetSafeHdc(), m_hglrc))  return false;  // Fehler -> Abbruch
	return true;  // Alles OK, keine Fehler!
}

void COpenGL::OnPaint()
{
	
	CRect rect; int cx,cy;
	CPaintDC dc(this); // device context for painting
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein.
	// OGL-Szene berechnen und zur Darstellung bringen

	// prepare a semaphore
	static BOOL 	bBusy = FALSE;
	// use the semaphore to enter this critic section
	if(bBusy) return;
	bBusy = TRUE;

	// specify the target DeviceContext of the subsequent OGL calls
	wglMakeCurrent(m_pcdc->GetSafeHdc(), m_hglrc);
	
	this->GetClientRect(rect);
	cx = rect.right - rect.left;
	cy = rect.bottom - rect.top;
	OnSizeGL(cx,cy);
	
	// call the virtual drawing procedure (to be overridden by user)
	
	OnDrawGL();
	glFlush();
	glFinish();
	SwapBuffers(wglGetCurrentDC());
	

	bBusy = FALSE;
	// free the target DeviceContext (window)
   //******************************** wglMakeCurrent(NULL,NULL);
		
	// CFrameWnd::OnPaint() soll zum Zeichnen von Meldungen nicht aufgerufen werden.
}

void COpenGL::OnSize(UINT nType, int cx, int cy)
{
	CFrameWnd::OnSize(nType, cx, cy);

	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein.
	OnSizeGL(cx, cy);
}

void COpenGL::OnSizeGL(int cx, int cy)
{
	// virtual
} 

void COpenGL::OnDrawGL()
{
	// virtual
} 

BOOL COpenGL::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein, und/oder benutzen Sie den Standard.
	return true;
	//return CFrameWnd::OnEraseBkgnd(pDC);
}
