#include "StdAfx.h"
#include "OpenGLMouse.h"
#include "prakt3Dlg.h"

COpenGLMouse::COpenGLMouse(void) {
}

COpenGLMouse::~COpenGLMouse(void) {
}

// COpenGL-Meldungshandler

bool COpenGLMouse::InitOpenGL(char* text, int x0, int y0, int cx, int cy) {
	if (COpenGL::InitOpenGL(text, x0, y0, cx, cy)) {
		m_idiaPick = 0;
		m_iEchoStatus = 0;
		m_iMouseStatus = 0;
		m_PdiaLoc.setCoords(0,0);
		m_VdiaMove.setCoords(0,0);
		p_temp1.setCoords(0,0);
		p_temp2.setCoords(0,0);
		return TRUE;
	} else {
		return false;
	}
}

void COpenGLMouse::setMouseStatus(int typ) {
	m_iMouseStatus = typ;
	m_PBasis.setCoords(0,0);
	m_iEchoStatus = ECHO_NONE;
	if (m_iMouseStatus == MOUSE_PICK) {
		m_idiaPick = 0;
	}
}

void COpenGLMouse::setMouseStatus(int typ, CGO_Point bp, int echo) {
	m_iMouseStatus = typ;
	m_PBasis = bp;
	m_iEchoStatus = echo;
}

void COpenGLMouse::setMouseStatus(int typ, float density) {
	m_iMouseStatus = typ;
	m_fSampleDensity = density;
}

int COpenGLMouse::getMouseStatus() {
	return m_iMouseStatus;
}

BEGIN_MESSAGE_MAP(COpenGLMouse, COpenGL)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
END_MESSAGE_MAP()

void COpenGLMouse::OnLButtonDown(UINT nFlags, CPoint point) {
	const GLuint SIZE = 100;

	glColor3f(0,0,1);	

	switch(m_iMouseStatus) {
		case MOUSE_LOCATE:
			getWorldCoord2D( point, &p_temp1);
			glLogicOp(GL_XOR);
		break;
		case MOUSE_MOVE:
			getWorldCoord2D( point, &p_temp1);
			glLogicOp(GL_XOR);
			//first = 0;
			m_bisDrawn = FALSE;
		break;
		case MOUSE_PICK:
			GLdouble* wc = NULL;
			GLuint selectBuf[SIZE];
			GLint hits;
			GLint viewport[4];
			GLint x, y;
			x = point.x;
			y = point.y;
			glGetIntegerv(GL_VIEWPORT, viewport);
			glSelectBuffer(SIZE, selectBuf);
			glRenderMode(GL_SELECT);
			glInitNames();
			glPushName(0);
			glMatrixMode(GL_PROJECTION);
			glPushMatrix();
			glLoadIdentity();
			// create 5x5 pixel picking region near cursor location
			CRect rect;
			GetClientRect(rect);
			gluPickMatrix((GLdouble) x, (GLdouble) (rect.bottom - y), 5.0, 5.0, viewport);
			wc = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getWC();
			gluOrtho2D(wc[0], wc[1], wc[2], wc[3]);
			Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->drawObjects(GL_SELECT);
			glMatrixMode(GL_PROJECTION);
			glPopMatrix();
			glFlush();
		
			hits = glRenderMode(GL_RENDER);
			// Nummer bereitstellen
			i_temp = 0;
			m_idiaPick = 0;
			if (hits > 0) {
				GLuint *ptr;
				ptr = (GLuint *) selectBuf;
				ptr+=3;
				i_temp = *ptr;
			}
		break;
	}
	COpenGL::OnLButtonDown(nFlags, point);
}

void COpenGLMouse::OnLButtonUp(UINT nFlags, CPoint point) {
	getWorldCoord2D(point, &p_temp2);
	glLogicOp(GL_COPY);
	
	switch (m_iMouseStatus) {
		case MOUSE_LOCATE:
			m_PdiaLoc.setCoords(p_temp1.getX(), p_temp1.getY());
			m_iMouseStatus = MOUSE_NONE;
			
			if (m_iEchoStatus != ECHO_NONE && m_bisDrawn) {
				glLogicOp(GL_XOR);
				glColor3f(1,1,1);
				switch (m_iEchoStatus) {
					case ECHO_RUBBER_BAND:
						glBegin(GL_LINES);
							glVertex2f(m_PRA.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRE.getY());
						glEnd();
					break;
					case ECHO_RECT:
						glBegin(GL_LINE_LOOP);
							glVertex2f(m_PRA.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRE.getY());
							glVertex2f(m_PRA.getX(), m_PRE.getY());
						glEnd();
					break;
				}
				glFlush();
			}
			glLogicOp(GL_COPY);
			m_bisDrawn = FALSE;
			m_iEchoStatus = MOUSE_NONE;
			Cprakt3Dlg::getInstance()->SendMessage(WM_USER_LOCATE);
		break;
		case MOUSE_MOVE:
			glLogicOp(GL_XOR);
			glBegin(GL_LINES);
				glVertex2f(m_PRA.getX(), m_PRA.getY());
				glVertex2f(m_PRE.getX(), m_PRE.getY());
			glEnd();
			glFlush();
			glLogicOp(GL_COPY);
			m_PdiaLoc.setCoords(p_temp1.getX(), p_temp1.getY());
			m_VdiaMove.setPoints(p_temp1, p_temp2);
			m_iMouseStatus = MOUSE_NONE;
			m_iEchoStatus = MOUSE_NONE;
			Cprakt3Dlg::getInstance()->SendMessage(WM_USER_MOVE);
		break;
		case MOUSE_PICK:
			if (i_temp != 0) {
				m_idiaPick = i_temp;
				m_iMouseStatus = MOUSE_NONE;
				m_iEchoStatus = MOUSE_NONE;
				Cprakt3Dlg::getInstance()->SendMessage(WM_USER_PICK, m_idiaPick);
			}
		break;
	}
	SwapBuffers(wglGetCurrentDC());
	COpenGL::OnLButtonUp(nFlags, point);
}

void COpenGLMouse::OnMouseMove(UINT nFlags, CPoint point) {
	CGO_Vector v;

	if (m_iMouseStatus != MOUSE_NONE) {
		HCURSOR hCursor = NULL;
		HCURSOR hPrevCursor = NULL;
		//hCursor = AfxGetApp()->LoadStandardCursor(IDC_SIZEALL);   // Wenn Kreuz nicht sichtbar sein sollte
		hCursor = AfxGetApp()->LoadStandardCursor(IDC_CROSS);
		hPrevCursor = SetCursor(hCursor);
	}
	
	if (m_iEchoStatus != ECHO_NONE && m_iMouseStatus == MOUSE_LOCATE && !(nFlags & MK_LBUTTON)) { // Nur, wenn Button NICHT gedrckt
		glLogicOp(GL_XOR);
		glColor3f(0,0,1);
			if (m_bisDrawn) {
				switch (m_iEchoStatus) {
					case ECHO_RUBBER_BAND:
						glBegin(GL_LINES);
							glVertex2f(m_PRA.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRE.getY());
						glEnd();
					break;
					case ECHO_RECT:
						glBegin(GL_LINE_LOOP);
							glVertex2f(m_PRA.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRA.getY());
							glVertex2f(m_PRE.getX(), m_PRE.getY());
							glVertex2f(m_PRA.getX(), m_PRE.getY());
						glEnd();
					break;
				}
				glFlush();
			}
			getWorldCoord2D( point, &p_temp2);
			m_PRA = m_PBasis;
			m_PRE = p_temp2;
			switch (m_iEchoStatus) {
				case ECHO_RUBBER_BAND:
					glBegin(GL_LINES);
						glVertex2f(m_PRA.getX(), m_PRA.getY());
						glVertex2f(m_PRE.getX(), m_PRE.getY());
					glEnd();
				break;
				case ECHO_RECT:
					glBegin(GL_LINE_LOOP);
						glVertex2f(m_PRA.getX(), m_PRA.getY());
						glVertex2f(m_PRE.getX(), m_PRA.getY());
						glVertex2f(m_PRE.getX(), m_PRE.getY());
						glVertex2f(m_PRA.getX(), m_PRE.getY());
					glEnd();
				break;
			}
			glFlush();
			m_bisDrawn = TRUE;
	}
	if (m_iEchoStatus == ECHO_NONE && m_iMouseStatus == MOUSE_SAMPLE && !(nFlags & MK_LBUTTON) ) { // Nur, wenn Button NICHT gedrckt
		getWorldCoord2D( point, &p_temp2);
		v.setPoints(m_PdiaLoc, p_temp2);
		if (v.getLength() > this->m_fSampleDensity) {
			m_PdiaLoc = p_temp2;
			Cprakt3Dlg::getInstance()->SendMessage(WM_USER_SAMPLE);
		}
	}

	if (nFlags & MK_LBUTTON) { // Button gedrckt?
		switch (m_iMouseStatus) {	
			case MOUSE_MOVE:
				if (m_bisDrawn) {
					glBegin(GL_LINES);
						glVertex2f(m_PRA.getX(), m_PRA.getY());
						glVertex2f(m_PRE.getX(), m_PRE.getY());
					glEnd();
					glFlush();
				}
				getWorldCoord2D(point, &p_temp2);
				m_PRA = p_temp1;
				m_PRE = p_temp2;
				glBegin(GL_LINES);
					glVertex2f(m_PRA.getX(), m_PRA.getY());
					glVertex2f(m_PRE.getX(), m_PRE.getY());
				glEnd();
				glFlush();
				m_bisDrawn = TRUE;
			break;
		}
	}
	SwapBuffers(wglGetCurrentDC());
	COpenGL::OnMouseMove(nFlags, point);
}

void COpenGLMouse::getWorldCoord2D(CPoint ip, CGO_Point* wp) {
	CRect rect;
	GLdouble wx, wy, wz;
	GLint viewport[4];
	GLdouble mvmatrix[16], projmatrix[16];
	GLint realy;  // OpenGL y-Koordinate
	glGetIntegerv (GL_VIEWPORT, viewport);
	glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
	glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);
	/*viewport[3] ist Hoehe in Fensterkoordinaten */
	//realy = viewport[3] - (GLint) ip.y - 1;
	this->GetClientRect(rect);
	realy = rect.bottom - (GLint) ip.y - 1;
	gluUnProject ((GLdouble) ip.x, (GLdouble) realy, 0.0, mvmatrix, projmatrix, viewport, &wx, &wy, &wz);
	wp->setCoords( (float) wx, (float) wy );
}

void COpenGLMouse::OnRButtonDown(UINT nFlags, CPoint point) {
	if (m_iEchoStatus != ECHO_NONE && m_bisDrawn) {
		glLogicOp(GL_XOR);
		glColor3f(0,0,1);
		switch (m_iEchoStatus) {
			case ECHO_RUBBER_BAND:
				glBegin(GL_LINES);
					glVertex2f(m_PRA.getX(), m_PRA.getY());
					glVertex2f(m_PRE.getX(), m_PRE.getY());
				glEnd();
			break;
			case ECHO_RECT:
				glBegin(GL_LINE_LOOP);
					glVertex2f(m_PRA.getX(), m_PRA.getY());
					glVertex2f(m_PRE.getX(), m_PRA.getY());
					glVertex2f(m_PRE.getX(), m_PRE.getY());
					glVertex2f(m_PRA.getX(), m_PRE.getY());
				glEnd();
			break;
		}
		glFlush();
		m_bisDrawn = FALSE;
	}	
	m_iMouseStatus = MOUSE_NONE;
	m_iEchoStatus = ECHO_NONE;
	glLogicOp(GL_COPY);
	
	COpenGL::OnRButtonDown(nFlags, point);
}

void COpenGLMouse::OnMButtonDown(UINT nFlags, CPoint point) {
	m_iMouseStatus = MOUSE_NONE;
	m_iEchoStatus = ECHO_NONE;
	COpenGL::OnMButtonDown(nFlags, point);
}

void COpenGLMouse::OnMButtonUp(UINT nFlags, CPoint point) {
	Cprakt3Dlg::getInstance()->SendMessage(WM_USER_INPUT);
	SwapBuffers(wglGetCurrentDC());
	COpenGL::OnMButtonUp(nFlags, point);
}

CGO_Point COpenGLMouse::getLocation() {
	return m_PdiaLoc;
}

CGO_Vector COpenGLMouse::getVector() {
	return m_VdiaMove;
}

GLuint COpenGLMouse::getPickedId() {
	return m_idiaPick - LISTID_OFFSET;
}