#pragma once
#include "OpenGL.h"
#include "Mouse.h"

#define WM_USER_PICK	(WM_USER + 1001)
#define WM_USER_LOCATE	(WM_USER + 1002)
#define WM_USER_VEC		(WM_USER + 1003)
#define WM_USER_MOVE	(WM_USER + 1004)
#define WM_USER_SAMPLE	(WM_USER + 1005)
#define WM_USER_INPUT	(WM_USER + 1006)

class COpenGLMouse : public COpenGL
{
public:
	COpenGLMouse(void);
	~COpenGLMouse(void);
	bool InitOpenGL(char*, int, int, int, int);
	void setMouseStatus(int);
	void setMouseStatus(int status, CGO_Point bp, int echo);
	void setMouseStatus(int status, float density);
	int getMouseStatus();
	CGO_Point getLocation();
	CGO_Vector getVector();
	GLuint getPickedId();
	void getWorldCoord2D(CPoint ip, CGO_Point* wp);

private:
	CGO_Point	p_temp1;
	CGO_Point	p_temp2;
	CGO_Point	m_PBasis;
	GLuint		i_temp;
	GLuint		m_iMouseStatus;
	GLuint		m_iEchoStatus;
	//GLint		first;
	bool		m_bisDrawn;			// Steuerung Gummiband
	CGO_Point	m_PRA;
	CGO_Point	m_PRE;
	GLfloat		m_fSampleDensity;	// Sample-Auflsung
	GLuint		m_idiaPick;			// bergabeparameter
	CGO_Point	m_PdiaLoc;
	CGO_Vector	m_VdiaMove;
	CGO_Point	m_PdiaSample;

protected:
	CGrafik* m_pGrafik;
	
public:
	DECLARE_MESSAGE_MAP()
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
};