// DialogDrawCircle.cpp : implementation file
//

#include "stdafx.h"
#include "prakt3.h"
#include "prakt3Dlg.h"
#include "DialogDrawCircle.h"


// CDialogDrawCircle dialog

IMPLEMENT_DYNAMIC(CDialogDrawCircle, CDialog)
CDialogDrawCircle::CDialogDrawCircle(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogDrawCircle::IDD, pParent)
{
}

CDialogDrawCircle::~CDialogDrawCircle()
{
}

BOOL CDialogDrawCircle::OnInitDialog() {
	if ( !CDialog::OnInitDialog() ) {
		return FALSE;
	}

	if ( Cprakt3Dlg::getInstance()->getCadState() == Cprakt3Dlg::CAD_DRAW_CIRCLE_PERIPHERAL ) {
        char buffer [120];
		CGO_Point p = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getLocation();

		sprintf(buffer, "%4.2f", p.getX());
		m_ceC1X.SetWindowText(buffer);
		m_ceC2X.SetWindowText(buffer);

		sprintf(buffer, "%4.2f", p.getX());
		m_ceC1Y.SetWindowText(buffer);
		m_ceC2Y.SetWindowText(buffer);
	}

	return TRUE;
}

void CDialogDrawCircle::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_C1X, m_ceC1X);
	DDX_Control(pDX, IDC_EDIT_C1Y, m_ceC1Y);
	DDX_Control(pDX, IDC_EDIT_C2X, m_ceC2X);
	DDX_Control(pDX, IDC_EDIT_C2Y, m_ceC2Y);
	DDX_Control(pDX, IDC_EDIT_PX, m_cePX);
	DDX_Control(pDX, IDC_EDIT_PY, m_cePY);
	DDX_Control(pDX, IDC_EDIT_RADIUS, m_ceRadius);
}


BEGIN_MESSAGE_MAP(CDialogDrawCircle, CDialog)
	ON_BN_CLICKED(IDOK_CP, OnBnClickedOkTwoPoints)
	ON_BN_CLICKED(IDOK_CR, OnBnClickedOkCenterRadius)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CDialogDrawCircle message handlers

void CDialogDrawCircle::OnBnClickedOkTwoPoints()
{
	char buffer [200];
	float x, y;
	CGO_Point c, p;
	CGO_Circle* pCircle;

	x = 0;
	y = 0;

	m_ceC1X.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x);
	m_ceC1Y.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y);
	c.setCoords(x, y);

	m_cePX.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x);
	m_cePY.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y);
	p.setCoords(x, y);

	pCircle = new CGO_Circle();
	pCircle->setByPeripheral(c, p);

	sprintf(buffer, "Dialog 'CDialogDrawCircle' is trying to add circle with C(%4.1f,%4.1f) and P(%4.1f,%4.1f)...", c.getX(), c.getY(), p.getX(), p.getY());
	CLogger::getInstance()->debug(buffer);

	Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->addObject(pCircle);
	
	OnOK();
}

void CDialogDrawCircle::OnBnClickedOkCenterRadius()
{
	char buffer [200];
	float x, y, radius;
	CGO_Point p;
	CGO_Circle* pCircle;

	m_ceC2X.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x);
	m_ceC2Y.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y);
	p.setCoords(x, y);

	m_ceRadius.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &radius);

	pCircle = new CGO_Circle();
	pCircle->setByRadius(p, radius);

	sprintf(buffer, "Dialog 'CDialogDrawCircle' is trying to add circle with C(%4.1f,%4.1f) and radius %4.1f...", p.getX(), p.getY(), radius);
	CLogger::getInstance()->debug(buffer);

	Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->addObject(pCircle);
	
	OnOK();
}

void CDialogDrawCircle::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}
