// DialogFlipObject.cpp : implementation file
//

#include "stdafx.h"
#include "prakt3.h"
#include "prakt3Dlg.h"
#include "DialogFlipObject.h"


// CDialogFlipObject dialog

IMPLEMENT_DYNAMIC(CDialogFlipObject, CDialog)
CDialogFlipObject::CDialogFlipObject(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogFlipObject::IDD, pParent)
{
}

CDialogFlipObject::~CDialogFlipObject()
{
}

BOOL CDialogFlipObject::OnInitDialog() {
	if ( !CDialog::OnInitDialog() ) {
		return FALSE;
	}

	char buffer [200];
	int state = Cprakt3Dlg::getInstance()->getCadState();
	
	if ( state >= Cprakt3Dlg::CAD_FLIP_PICK ) {
		sprintf(buffer, "%d", Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getPickedId());
		m_ceObjectId.SetWindowText(buffer);
	}
	if ( state >= Cprakt3Dlg::CAD_FLIP_LOC_STRAIGHT_1ST ) {
		CGO_Point bp = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getLocation();
		sprintf(buffer, "%4.2f", bp.getX());
		m_ceX1.SetWindowText(buffer);
		sprintf(buffer, "%4.2f", bp.getY());
		m_ceY1.SetWindowText(buffer);
	}

	return TRUE;
}

void CDialogFlipObject::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OBJECTID, m_ceObjectId);
	DDX_Control(pDX, IDC_EDIT_X1, m_ceX1);
	DDX_Control(pDX, IDC_EDIT_Y1, m_ceY1);
	DDX_Control(pDX, IDC_EDIT_X2, m_ceX2);
	DDX_Control(pDX, IDC_EDIT_Y2, m_ceY2);
}


BEGIN_MESSAGE_MAP(CDialogFlipObject, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_FLIPX, OnBnClickedButtonFlipX)
	ON_BN_CLICKED(IDC_BUTTON_FLIPY, OnBnClickedButtonFlipY)
	ON_BN_CLICKED(IDC_BUTTON_FLIPORIGIN, OnBnClickedButtonFlipOrigin)
	ON_BN_CLICKED(IDC_BUTTON_FLIPSTRAIGHT, OnBnClickedButtonFlipStraight)
END_MESSAGE_MAP()


int CDialogFlipObject::getObjectId() {
	char buffer [8];
	int oId = -1;

	m_ceObjectId.GetWindowText(buffer, 8);
	sscanf(buffer, "%d", &oId);

	return oId;
}

// CDialogFlipObject message handlers

void CDialogFlipObject::OnBnClickedOk() {
	OnOK();
}

void CDialogFlipObject::OnBnClickedCancel() {
	OnCancel();
}

void CDialogFlipObject::OnBnClickedButtonFlipX() {
	char buffer [200];
	int oId;
	CGO_GeoObject* pGeoObject;

	oId = getObjectId();

	sprintf(buffer, "Dialog 'CDialogFlipObject' is trying to flip object #%i horizontal...", oId);
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	pGeoObject->flipX();
	pGeoObject->draw();

	OnOK();
}

void CDialogFlipObject::OnBnClickedButtonFlipY() {
	char buffer [200];
	int oId;
	CGO_GeoObject* pGeoObject;

	oId = getObjectId();

	sprintf(buffer, "Dialog 'CDialogFlipObject' is trying to flip object #%i vertical...", oId);
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	pGeoObject->flipY();
	pGeoObject->draw();

	OnOK();
}

void CDialogFlipObject::OnBnClickedButtonFlipOrigin() {
	char buffer [200];
	int oId;
	CGO_GeoObject* pGeoObject;

	oId = getObjectId();

	sprintf(buffer, "Dialog 'CDialogFlipObject' is trying to flip object #%i on origin of ordinates...", oId);
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	pGeoObject->flipOrigin();
	pGeoObject->draw();

	OnOK();
}

void CDialogFlipObject::OnBnClickedButtonFlipStraight() {
	char buffer [200];
	int oId;
	float x1, y1, x2, y2;
	CGO_Point p1, p2;
	CGO_GeoObject* pGeoObject;

	oId = getObjectId();
	x1 = 0;
	y1 = 0;
	x2 = 0;
	y2 = 0;

	m_ceX1.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x1);
	m_ceY1.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y1);
	p1.setCoords(x1, y1);

	m_ceX2.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x2);
	m_ceY2.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y2);
	p2.setCoords(x2, y2);

	sprintf(buffer, "Dialog 'CDialogFlipObject' is trying to flip object #%i on straight through P1(%4.1f,%4.1f), P2(%4.1f,%4.1f)...", oId, p1.getX(), p1.getY(), p2.getX(), p2.getY());
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	pGeoObject->flipStraight(p1, p2);
	pGeoObject->draw();

	OnOK();
}