// DialogMoveObject.cpp : implementation file
//

#include "stdafx.h"
#include "prakt3.h"
#include "prakt3Dlg.h"
#include "DialogMoveObject.h"


// CDialogMoveObject dialog

IMPLEMENT_DYNAMIC(CDialogMoveObject, CDialog)
CDialogMoveObject::CDialogMoveObject(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogMoveObject::IDD, pParent)
{
}

CDialogMoveObject::~CDialogMoveObject()
{
}

BOOL CDialogMoveObject::OnInitDialog() {
	if ( !CDialog::OnInitDialog() ) {
		return FALSE;
	}

	if ( Cprakt3Dlg::getInstance()->getCadState() == Cprakt3Dlg::CAD_MOVE_SET_VECTOR ) {
		char buffer [200];
		sprintf(buffer, "%d", Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getPickedId());
		m_ceObjectId.SetWindowText(buffer);
	}

	return TRUE;
}

void CDialogMoveObject::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OBJECTID, m_ceObjectId);
	DDX_Control(pDX, IDC_EDIT_VECTOR_X, m_ceVectorX);
	DDX_Control(pDX, IDC_EDIT_VECTOR_Y, m_ceVectorY);
}


BEGIN_MESSAGE_MAP(CDialogMoveObject, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CDialogMoveObject message handlers

void CDialogMoveObject::OnBnClickedOk()
{
	char buffer [200];
	int oId;
	float dx, dy;
	CGO_Vector* v = new CGO_Vector();
	CGO_GeoObject* pGeoObject;

	oId = -1;
	dx = 0;
	dy = 0;

	m_ceObjectId.GetWindowText(buffer, 8);
	sscanf(buffer, "%d", &oId);

	m_ceVectorX.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &dx);
	m_ceVectorY.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &dy);
	v->setCoords(dx, dy);

	sprintf(buffer, "Dialog 'CDialogMoveObject' is trying to move object #%i by (%4.1f,%4.1f)...", oId, v->getDX(), v->getDY());
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	pGeoObject->move(v);
	pGeoObject->draw();

	OnOK();
}

void CDialogMoveObject::OnBnClickedCancel()
{
	OnCancel();
}
