// DialogRotateObject.cpp : implementation file
//

#include "stdafx.h"
#include "prakt3.h"
#include "prakt3Dlg.h"
#include "DialogRotateObject.h"


// CDialogRotateObject dialog

IMPLEMENT_DYNAMIC(CDialogRotateObject, CDialog)
CDialogRotateObject::CDialogRotateObject(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogRotateObject::IDD, pParent)
{
}

CDialogRotateObject::~CDialogRotateObject()
{
}


BOOL CDialogRotateObject::OnInitDialog() {
	if ( !CDialog::OnInitDialog() ) {
		return FALSE;
	}

	char buffer [200];
	int state = Cprakt3Dlg::getInstance()->getCadState();
	
	if ( state >= Cprakt3Dlg::CAD_ROTATE_LOC_BASEPOINT ) {
		sprintf(buffer, "%d", Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getPickedId());
		m_ceObjectId.SetWindowText(buffer);
	}
	if ( state >= Cprakt3Dlg::CAD_ROTATE_SET_RADIUS ) {
		CGO_Point bp = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getLocation();
		sprintf(buffer, "%4.2f", bp.getX());
		m_ceBasepointX.SetWindowText(buffer);
		sprintf(buffer, "%4.2f", bp.getY());
		m_ceBasepointY.SetWindowText(buffer);
	}

	return TRUE;
}

void CDialogRotateObject::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OBJECTID, m_ceObjectId);
	DDX_Control(pDX, IDC_EDIT_ANGLE, m_ceAngle);
	DDX_Control(pDX, IDC_EDIT_BPX, m_ceBasepointX);
	DDX_Control(pDX, IDC_EDIT_BPY, m_ceBasepointY);
}


BEGIN_MESSAGE_MAP(CDialogRotateObject, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CDialogRotateObject message handlers

void CDialogRotateObject::OnBnClickedOk()
{
	char buffer [200];
	int oId;
	float angle, x, y;
	CGO_Point p;
	CGO_GeoObject* pGeoObject;

	angle = 0;
	x = 0;
	y = 0;

	m_ceObjectId.GetWindowText(buffer, 8);
	sscanf(buffer, "%d", &oId);

	m_ceAngle.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &angle);

	m_ceBasepointX.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x);
	m_ceBasepointY.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y);

	sprintf(buffer, "Dialog 'CDialogRotateObject' is trying to rotate object #%i by %4.1f degree...", oId, angle);
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	if ( x == 0 && y == 0 ) {
		pGeoObject->rotate(angle);
	} else {
		p.setCoords(x, y);
		pGeoObject->rotateBasepoint(p, angle);
	}
	pGeoObject->draw();

	OnOK();
}

void CDialogRotateObject::OnBnClickedCancel()
{
	OnCancel();
}
