// DialogScaleObject.cpp : implementation file
//

#include "stdafx.h"
#include "prakt3.h"
#include "prakt3Dlg.h"
#include "DialogScaleObject.h"


// CDialogScaleObject dialog

IMPLEMENT_DYNAMIC(CDialogScaleObject, CDialog)
CDialogScaleObject::CDialogScaleObject(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogScaleObject::IDD, pParent)
{
}

CDialogScaleObject::~CDialogScaleObject()
{
}

BOOL CDialogScaleObject::OnInitDialog() {
	if ( !CDialog::OnInitDialog() ) {
		return FALSE;
	}

	char buffer [200];
	int state = Cprakt3Dlg::getInstance()->getCadState();
	
	if ( state >= Cprakt3Dlg::CAD_SCALE_LOC_BASEPOINT ) {
		sprintf(buffer, "%d", Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getPickedId());
		m_ceObjectId.SetWindowText(buffer);
	}
	if ( state >= Cprakt3Dlg::CAD_SCALE_SET_FACTOR ) {
		CGO_Point bp = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getLocation();
		sprintf(buffer, "%4.2f", bp.getX());
		m_ceBasepointX.SetWindowText(buffer);
		sprintf(buffer, "%4.2f", bp.getY());
		m_ceBasepointY.SetWindowText(buffer);
	}

	return TRUE;
}

void CDialogScaleObject::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OBJECTID, m_ceObjectId);
	DDX_Control(pDX, IDC_EDIT_FACTOR, m_ceScaleFactor);
	DDX_Control(pDX, IDC_EDIT_BPX, m_ceBasepointX);
	DDX_Control(pDX, IDC_EDIT_BPY, m_ceBasepointY);
}


BEGIN_MESSAGE_MAP(CDialogScaleObject, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CDialogScaleObject message handlers

void CDialogScaleObject::OnBnClickedOk()
{
	char buffer [200];
	int oId = -1;
	float factor, x, y;
	CGO_Point p;
	CGO_GeoObject* pGeoObject;

	factor = 1;
	x = 0;
	y = 0;

	m_ceObjectId.GetWindowText(buffer, 8);
	sscanf(buffer, "%d", &oId);

	m_ceScaleFactor.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &factor);

	m_ceBasepointX.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &x);
	m_ceBasepointY.GetWindowText(buffer, 8);
	sscanf(buffer, "%f", &y);

	sprintf(buffer, "Dialog 'CDialogScaleObject' is trying to scale object #%i by %4.1f...", oId, factor);
	CLogger::getInstance()->debug(buffer);

	pGeoObject = Cprakt3Dlg::getInstance()->getMyOpenGLWindow()->getGrafik()->getDatabase()->getObject(oId);

	if ( pGeoObject == NULL ) {
		OnCancel();
		return;
	}

	if ( x == 0 && y == 0 ) {
		pGeoObject->scale(factor);
		pGeoObject->draw();
	} else {
		p.setCoords(x, y);
		pGeoObject->scaleBasepoint(p, factor);
		pGeoObject->draw();
	}

	OnOK();
}

void CDialogScaleObject::OnBnClickedCancel()
{
	OnCancel();
}
