#pragma once

class CGO_Circle : public CGO_GeoObject
{
	private:
		CGO_Point m_Center;		//Mittelpunkt
		CGO_Point m_Peripheral;	//Peripheriepunkt
		float m_Radius;			//Radius

		void updateRadius();

	public:
		CGO_Circle(void);	//cstr
		~CGO_Circle(void);	//dstr

		void  Serialize(CArchive &a);
		void  removeObject(void);

		void  setByPeripheral(CGO_Point c, CGO_Point p);
		void  setByRadius(CGO_Point c, float radius);
		float getRadius(void);
		void  draw(void);
		void  move(CGO_Vector* v);
		void  rotate(float);
		void  rotateBasepoint(CGO_Point p, float angle);
		void  scale(float);
		void  scaleBasepoint(CGO_Point p, float factor);
		void  flipX(void);
		void  flipY(void);
		void  flipOrigin(void);
		void  flipStraight(CGO_Point p1, CGO_Point p2);

		DECLARE_SERIAL(CGO_Circle)
};