#pragma once
#include "CDatabase.h"
#include "CGO_Vector.h"
#include "CGO_Point.h"

//forward declarations of point and vector:
class CGO_Point;
class CGO_Vector;

class CGO_GeoObject : public CObject
{
	public:
		CGO_GeoObject(void);
		~CGO_GeoObject(void);

		int  getObjectId(void);

		static void resetIdFactory(void);
		virtual void Serialize(CArchive &a);
		virtual void removeObject(void);

		virtual void draw(void);
		virtual void move(CGO_Vector* v);
		virtual void rotate(float angle);
		virtual void rotateBasepoint(CGO_Point p, float angle);
		virtual void scale(float factor);
		virtual void scaleBasepoint(CGO_Point p, float factor);
		virtual void flipX(void);
		virtual void flipY(void);
		virtual void flipOrigin(void);
		virtual void flipStraight(CGO_Point p1, CGO_Point p2);

	protected:
		static int idFactory;
		int m_ObjectId;
		int m_DisplayListId;

	DECLARE_SERIAL(CGO_GeoObject)
};