#include "StdAfx.h"
#include <math.h>

CGO_Vector::CGO_Vector() {
}

CGO_Vector::~CGO_Vector() {
}

void CGO_Vector::setCoords(float dx, float dy) {
	m_DX = dx;
	m_DY = dy;
}

void CGO_Vector::setPoints(CGO_Point p1, CGO_Point p2) {
	m_DX = p2.getX() - p1.getX();
	m_DY = p2.getY() - p1.getY();
}

void CGO_Vector::setDX(float dx) {
	m_DX = dx;
}

void CGO_Vector::setDY(float dy) {
	m_DY = dy;
}

float CGO_Vector::getDX() {
	return m_DX;
}

float CGO_Vector::getDY() {
	return m_DY;
}

float CGO_Vector::getLength() {
	return sqrt( pow(m_DX, 2) + pow(m_DY, 2) );
}

float CGO_Vector::getAngle() {
	float angle = 180 * acos(m_DX / this->getLength()) / (float) M_PI;
	if ( m_DY < 0 ) {
		angle = angle + 180;
	}

	char message [200];
	sprintf(message, "Vector (%4.1f, %4.1f) has angle %4.1f degree to x-axis.", m_DX, m_DY, angle);
	CLogger::getInstance()->debug(message);

	return angle;
}