#include "StdAfx.h"
#include "grafik.h"
#include "CGO_GeoObject.h"

CGrafik::CGrafik(void) {	
	m_WC_xmin = -500;
	m_WC_xmax =  500;
	m_WC_ymin = -500;
	m_WC_ymax =  500;
}

CGrafik::~CGrafik(void) {
}

void CGrafik::load(LPCTSTR fileName) {
	m_Database.load(fileName);
}

void CGrafik::save(LPCTSTR fileName) {
	m_Database.save(fileName);
}

void CGrafik::init() {
	CLogger::getInstance()->info("Initializing graphics...");
}

void CGrafik::draw() {
	this->drawObjects(GL_RENDER);
}

void CGrafik::drawObjects(GLenum mode) {
	char buffer [200];
	int listId;

	for ( int i = 0; i < m_Database.getCount(); i++ ) {
		listId = i + LISTID_OFFSET;

		if ( !glIsList(listId) ) {
			sprintf(buffer, "Display list #%i not found!", i);
			CLogger::getInstance()->debug(buffer);
			continue;
		}
		if (mode == GL_SELECT) {
			glLoadName(listId);
		}
		sprintf(buffer, "Drawing display list #%i...", i);
		CLogger::getInstance()->debug(buffer);
		glCallList(listId);
	}
	glFlush();

	CLogger::getInstance()->debug("Drawn all display lists.");
}

void CGrafik::setWC(float xmin, float xmax, float ymin, float ymax) {
	if ( xmin >= xmax || ymin >= ymax  ) {
		return;
	}

	m_WC_xmin = (GLdouble) xmin;
	m_WC_xmax = (GLdouble) xmax;
	m_WC_ymin = (GLdouble) ymin;
	m_WC_ymax = (GLdouble) ymax;

	char buffer [200];
	sprintf(buffer, "World coordinates are now X(%4.1f, %4.1f), Y(%4.1f, %4.1f)", m_WC_xmin, m_WC_xmax, m_WC_ymin, m_WC_ymax);
	CLogger::getInstance()->debug(buffer);
}

GLdouble* CGrafik::getWC() {
	GLdouble *coords = new GLdouble [3];
	coords[0] = m_WC_xmin;
	coords[1] = m_WC_xmax;
	coords[2] = m_WC_ymin;
	coords[3] = m_WC_ymax;
	return coords;
}

CDatabase* CGrafik::getDatabase() {
	return &m_Database;
}
