// prakt3Dlg.cpp : Implementierungsdatei

#include "StdAfx.h"
#include "Prakt3.h"
#include "Prakt3Dlg.h"
#include "OpenGLMouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


static UINT BASED_CODE indicators[] =
{
    ID_INDICATOR_BAR
};


// Cprakt3Dlg Dialogfeld

Cprakt3Dlg::Cprakt3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cprakt3Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iCadState = CAD_IDLE;

	sprintf(m_cSBText, "CAD Control Center");
}

Cprakt3Dlg* Cprakt3Dlg::m_pInstance = NULL;

Cprakt3Dlg* Cprakt3Dlg::getInstance()
{
	if ( m_pInstance == NULL ) {
		m_pInstance = new Cprakt3Dlg();
	}
	return m_pInstance;
}

void Cprakt3Dlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(Cprakt3Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()

	ON_MESSAGE(WM_USER_PICK, OnPick)
	ON_MESSAGE(WM_USER_LOCATE, OnLocate)
	ON_MESSAGE(WM_USER_MOVE, OnMove)
	ON_MESSAGE(WM_USER_SAMPLE, OnSample)
	ON_MESSAGE(WM_USER_INPUT, OnUserInput)

	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDSAVE, OnBnClickedSave)
	ON_BN_CLICKED(IDLOAD, OnBnClickedLoad)
	ON_BN_CLICKED(IDC_DRAW_LINE, OnBnClickedDrawLine)
	ON_BN_CLICKED(IDC_DRAW_CIRCLE, OnBnClickedDrawCircle)
	ON_BN_CLICKED(IDC_DEL_OBJECT, OnBnClickedDelObject)
	ON_BN_CLICKED(IDC_MOVE_OBJECT, OnBnClickedMoveObject)
	ON_BN_CLICKED(IDC_ROTATE_OBJECT, OnBnClickedRotateObject)
	ON_BN_CLICKED(IDC_SCALE_OBJECT, OnBnClickedScaleObject)
	ON_BN_CLICKED(IDC_FLIP_OBJECT, OnBnClickedFlipObject)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_WC, OnBnClickedButtonChangeWC)
END_MESSAGE_MAP()


myOpenGL* Cprakt3Dlg::getMyOpenGLWindow() {
	return &m_wOpenGL;
}

int Cprakt3Dlg::getCadState() {
	return m_iCadState;
}

// Cprakt3Dlg Meldungshandler

BOOL Cprakt3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// TODO: Hier zustzliche Initialisierung einfgen
	// init Logger
	CLogger::getInstance()->setLogLevel(CLogger::L_DEBUG);
	CLogger::getInstance()->info("Logger initialized.");
	
	// create status bar
	m_statusBar.Create(this);					//We create the status bar
	m_statusBar.SetIndicators(indicators, 1);	//Set the number of panes 
	m_statusBar.SetPaneInfo(0, ID_INDICATOR_BAR, SBPS_STRETCH, 0);
	m_statusBar.SetPaneText(0, m_cSBText, TRUE);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, ID_INDICATOR_BAR);

	// OGL-Fenster konfigurieren
	m_wOpenGL.InitOpenGL("CAD-Programm (-500, 500 | -500, 500)", 0, 0, 500, 540);
	m_wOpenGL.getGrafik()->init();
	m_wOpenGL.getGrafik()->draw();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void Cprakt3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
		CDialog::OnSysCommand(nID, lParam);
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
// den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
// Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void Cprakt3Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR Cprakt3Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/**
 * Receives message "picked" from OpenGLMouse
 */
LRESULT Cprakt3Dlg::OnPick(WPARAM wParam, LPARAM lParam) {
	char buffer [200];
	int oId = m_wOpenGL.getPickedId();

	sprintf(buffer, "Object #%i picked!", oId);
	CLogger::getInstance()->debug(buffer);

	switch ( m_iCadState ) {
		case CAD_IDLE :
			// do nothing
		break;
		case CAD_DELETE :
			m_wOpenGL.getGrafik()->getDatabase()->removeObjectById( oId );

			m_iCadState = CAD_IDLE;
			m_wOpenGL.setMouseStatus( MOUSE_NONE );
			m_statusBar.SetPaneText(0, m_cSBText, TRUE);
			//AfxMessageBox("Objekt gelscht!", MB_ICONINFORMATION | MB_OK);
		break;
		case CAD_MOVE_PICK :
			m_statusBar.SetPaneText(0, "Aktion: Verschieben bei gedrckter Maustaste | Men: mittlere Maustaste", TRUE);
			m_wOpenGL.setMouseStatus( MOUSE_MOVE );
			m_iCadState = CAD_MOVE_SET_VECTOR;
		break;
		case CAD_ROTATE_PICK :
			m_statusBar.SetPaneText(0, "Aktion: Basispunkt lokalisieren | Men: mittlere Maustaste", TRUE);
			m_wOpenGL.setMouseStatus( MOUSE_LOCATE );
			m_iCadState = CAD_ROTATE_LOC_BASEPOINT;
		break;
		case CAD_SCALE_PICK :
			m_statusBar.SetPaneText(0, "Aktion: Basispunkt lokalisieren | Men: mittlere Maustaste", TRUE);
			m_wOpenGL.setMouseStatus( MOUSE_LOCATE );
			m_iCadState = CAD_SCALE_LOC_BASEPOINT;
		break;
		case CAD_FLIP_PICK :
			m_statusBar.SetPaneText(0, "Aktion: Spiegelgerade zeichnen | Men: mittlere Maustaste", MB_ICONINFORMATION | MB_OK);
			m_wOpenGL.setMouseStatus( MOUSE_LOCATE );
			m_iCadState = CAD_FLIP_LOC_STRAIGHT_1ST;
		break;
	}

	m_wOpenGL.OnDrawGL();
	return 0;
}

/**
 * Receives message "locate" from OpenGLMouse
 */
LRESULT Cprakt3Dlg::OnLocate(WPARAM wParam, LPARAM lParam) {
	char buffer [200];
	CGO_Line* pLine;
	CGO_Circle* pCircle;
	CGO_Point p = m_wOpenGL.getLocation();
	
	switch (m_iCadState) {
		case CAD_DRAW_LINE_FIRST_POINT :
			sprintf(buffer, "Mouse Event: Line start point located at (%4.1f, %4.1f).", p.getX(), p.getY());
			CLogger::getInstance()->debug(buffer);

			m_gPoint = p;
			m_iCadState = CAD_DRAW_LINE_SECOND_POINT;
			m_wOpenGL.setMouseStatus( MOUSE_LOCATE, p, ECHO_RUBBER_BAND );
			m_statusBar.SetPaneText(0, "Aktion: 2. Punkt whlen | Men: mittlere Maustaste", TRUE);
		break;
		case CAD_DRAW_CIRCLE_CENTER :
			sprintf(buffer, "Mouse Event: Circle center located at (%4.1f, %4.1f).", p.getX(), p.getY());
			CLogger::getInstance()->debug(buffer);

			m_gPoint = p;
			m_iCadState = CAD_DRAW_CIRCLE_PERIPHERAL;
			m_wOpenGL.setMouseStatus( MOUSE_LOCATE, p, ECHO_RUBBER_BAND );
			m_statusBar.SetPaneText(0, "Aktion: Radius whlen | Men: mittlere Maustaste", TRUE);
		break;
		case CAD_DRAW_LINE_SECOND_POINT :
			sprintf(buffer, "Mouse Event: Line end point located at (%4.1f, %4.1f). Drawing line...", p.getX(), p.getY());
			CLogger::getInstance()->debug(buffer);

			m_iCadState = CAD_IDLE;
			m_wOpenGL.setMouseStatus( MOUSE_NONE );
			m_statusBar.SetPaneText(0, m_cSBText, TRUE);

			pLine = new CGO_Line();
			pLine->setPoints(m_gPoint, p);
			pLine->draw();
			m_wOpenGL.getGrafik()->getDatabase()->addObject( pLine );
			m_wOpenGL.OnDrawGL();
		break;
		case CAD_DRAW_CIRCLE_PERIPHERAL :
			sprintf(buffer, "Mouse Event: Circle peripheral point located at (%4.1f, %4.1f). Drawing circle...", p.getX(), p.getY());
			CLogger::getInstance()->debug(buffer);

			m_iCadState = CAD_IDLE;
			m_wOpenGL.setMouseStatus( MOUSE_NONE );
			m_statusBar.SetPaneText(0, m_cSBText, TRUE);

			pCircle = new CGO_Circle();
			pCircle->setByPeripheral(m_gPoint, p);
			pCircle->draw();
			m_wOpenGL.getGrafik()->getDatabase()->addObject( pCircle );
			m_wOpenGL.OnDrawGL();
		break;
		case CAD_ROTATE_LOC_BASEPOINT :
			{
				sprintf(buffer, "Mouse Event: Base point for rotation located at (%4.1f, %4.1f).", p.getX(), p.getY());
				CLogger::getInstance()->debug(buffer);

				m_iCadState = CAD_ROTATE_SET_RADIUS;
				m_statusBar.SetPaneText(0, "Bitte geben Sie die gewnschten Daten ein.", TRUE);

				CDialogRotateObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
				m_iCadState = CAD_IDLE;
				m_statusBar.SetPaneText(0, m_cSBText, TRUE);
			}
		break;
		case CAD_SCALE_LOC_BASEPOINT :
			{
				sprintf(buffer, "Mouse Event: Base point for scaling located at (%4.1f, %4.1f).", p.getX(), p.getY());
				CLogger::getInstance()->debug(buffer);

				m_iCadState = CAD_SCALE_SET_FACTOR;
				m_statusBar.SetPaneText(0, "Bitte geben Sie die gewnschten Daten ein.", TRUE);

				CDialogScaleObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
				m_iCadState = CAD_IDLE;
				m_statusBar.SetPaneText(0, m_cSBText, TRUE);
			}
		break;
		case CAD_FLIP_LOC_STRAIGHT_1ST :
			{
				sprintf(buffer, "Mouse Event: Start point for flip straight located at (%4.1f, %4.1f).", p.getX(), p.getY());
				CLogger::getInstance()->debug(buffer);

				m_gPoint = p;
				m_wOpenGL.setMouseStatus( MOUSE_LOCATE, p, ECHO_RUBBER_BAND );
				m_iCadState = CAD_FLIP_LOC_STRAIGHT_2ND;
				m_statusBar.SetPaneText(0, "Aktion: 2. Punkt whlen | Men: mittlere Maustaste", TRUE);
			}
		break;
		case CAD_FLIP_LOC_STRAIGHT_2ND :
			{
				sprintf(buffer, "Mouse Event: End point for flip straight set: (%4.1f, %4.1f). Flipping...", p.getX(), p.getY());
				CLogger::getInstance()->debug(buffer);

				CGO_GeoObject* pGeoObject = m_wOpenGL.getGrafik()->getDatabase()->getObject( m_wOpenGL.getPickedId() );
				pGeoObject->flipStraight( m_gPoint, p );
				pGeoObject->draw();

				m_iCadState = CAD_IDLE;
				m_statusBar.SetPaneText(0, m_cSBText, TRUE);
				m_wOpenGL.setMouseStatus( MOUSE_NONE );
				m_wOpenGL.OnDrawGL();
			}
		break;
		default :
			AfxMessageBox("Illegal operation!", MB_ICONSTOP|MB_OK);
			m_iCadState = CAD_IDLE;
			m_wOpenGL.setMouseStatus( MOUSE_NONE );
			m_statusBar.SetPaneText(0, m_cSBText, TRUE);
	}

	return 0;
}

/**
 * Receives message "move" from OpenGLMouse
 */
LRESULT Cprakt3Dlg::OnMove(WPARAM wParam, LPARAM lParam) {
	char buffer [200];
	int oId = m_wOpenGL.getPickedId();
	CGO_GeoObject* pGeoObject = m_wOpenGL.getGrafik()->getDatabase()->getObject(oId);
	CGO_Vector v = m_wOpenGL.getVector();

	if ( v.getLength() == 0 ) {
		return -1;
	}

	switch (m_iCadState) {
		case CAD_MOVE_SET_VECTOR :
			sprintf(buffer, "Mouse Event: Moving picked object #%i by vector (%4.1f, %4.1f).", oId, v.getDX(), v.getDY());
			CLogger::getInstance()->debug(buffer);

			pGeoObject->move(&v);
		break;
	}

	m_wOpenGL.setMouseStatus( MOUSE_NONE );
	m_iCadState = CAD_IDLE;
	m_statusBar.SetPaneText(0, m_cSBText, TRUE);

	pGeoObject->draw();
	m_wOpenGL.OnDrawGL();
	return 0;
}

/**
 * Receives message "sample" from OpenGLMouse
 */
LRESULT Cprakt3Dlg::OnSample(WPARAM wParam, LPARAM lParam) {
	return 0;
}

/**
 * Receives message "user input" from OpenGLMouse
 */
LRESULT Cprakt3Dlg::OnUserInput(WPARAM wParam, LPARAM lParam) {
	m_statusBar.SetPaneText(0, "Bitte geben Sie die gewnschten Daten ein.", TRUE);

	switch (m_iCadState) {
		case CAD_DELETE :
			{
				CDialogDelObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_MOVE_PICK :
		case CAD_MOVE_SET_VECTOR :
			{	
				CDialogMoveObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_DRAW_LINE_FIRST_POINT :
		case CAD_DRAW_LINE_SECOND_POINT :
			{
				CDialogDrawLine dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_DRAW_CIRCLE_CENTER :
		case CAD_DRAW_CIRCLE_PERIPHERAL :
			{
				CDialogDrawCircle dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_ROTATE_PICK :
		case CAD_ROTATE_SET_RADIUS :
		case CAD_ROTATE_LOC_BASEPOINT :
			{
				CDialogRotateObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_SCALE_PICK :
		case CAD_SCALE_SET_FACTOR :
		case CAD_SCALE_LOC_BASEPOINT :
			{
				CDialogScaleObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
		case CAD_FLIP_PICK :
		case CAD_FLIP_LOC_STRAIGHT_1ST :
			{
				CDialogFlipObject dlg;
				if ( dlg.DoModal() != IDCANCEL ) {
					m_wOpenGL.OnDrawGL();
				}
			}
		break;
	}

	m_iCadState = CAD_IDLE;
	m_statusBar.SetPaneText(0, m_cSBText, TRUE);

	return 0;
}

/**
 * Fired when button "Cancel" was clicked.
 */
void Cprakt3Dlg::OnBnClickedCancel() {
	OnCancel();
}

/**
 * Fired when button "Save" was clicked.
 */
void Cprakt3Dlg::OnBnClickedSave() {
	m_statusBar.SetPaneText(0, "Speichere Grafik...", TRUE);

	CFileDialog file(FALSE, "dat", "*.dat");
	if ( file.DoModal() == IDOK ) {
		m_wOpenGL.getGrafik()->save( file.GetFileName() );
	}

	m_statusBar.SetPaneText(0, m_cSBText, TRUE);
}

/**
 * Fired when button "Load" was clicked.
 */
void Cprakt3Dlg::OnBnClickedLoad() {
	m_statusBar.SetPaneText(0, "Lade Grafik...", TRUE);

	CFileDialog file(TRUE, "dat", "*.dat");
	if ( file.DoModal() == IDOK )	{
		m_wOpenGL.getGrafik()->load( file.GetFileName() );
		m_wOpenGL.OnDrawGL();
	}

	m_statusBar.SetPaneText(0, m_cSBText, TRUE);
}

/**
 * Fired when button "Draw line" was clicked.
 */
void Cprakt3Dlg::OnBnClickedDrawLine() {
	m_iCadState = CAD_DRAW_LINE_FIRST_POINT;
	m_wOpenGL.setMouseStatus( MOUSE_LOCATE );
	m_statusBar.SetPaneText(0, "Aktion: 1. Punkt whlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Draw circle" was clicked.
 */
void Cprakt3Dlg::OnBnClickedDrawCircle() {
	m_iCadState = CAD_DRAW_CIRCLE_CENTER;
	m_wOpenGL.setMouseStatus( MOUSE_LOCATE );
	m_statusBar.SetPaneText(0, "Aktion: Mittelpunkt whlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Del object" was clicked.
 */
void Cprakt3Dlg::OnBnClickedDelObject() {
	m_iCadState = CAD_DELETE;
	m_wOpenGL.setMouseStatus( MOUSE_PICK );
	m_statusBar.SetPaneText(0, "Aktion: Objekt auswhlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Move object" was clicked.
 */
void Cprakt3Dlg::OnBnClickedMoveObject() {
	m_iCadState = CAD_MOVE_PICK;
	m_wOpenGL.setMouseStatus( MOUSE_PICK );
	m_statusBar.SetPaneText(0, "Aktion: Objekt auswhlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Rotate object" was clicked.
 */
void Cprakt3Dlg::OnBnClickedRotateObject() {
	m_iCadState = CAD_ROTATE_PICK;
	m_wOpenGL.setMouseStatus( MOUSE_PICK );
	m_statusBar.SetPaneText(0, "Aktion: Objekt auswhlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Scale object" was clicked.
 */
void Cprakt3Dlg::OnBnClickedScaleObject() {
	m_iCadState = CAD_SCALE_PICK;
	m_wOpenGL.setMouseStatus( MOUSE_PICK );
	m_statusBar.SetPaneText(0, "Aktion: Objekt auswhlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Flip object" was clicked.
 */
void Cprakt3Dlg::OnBnClickedFlipObject() {
	m_iCadState = CAD_FLIP_PICK;
	m_wOpenGL.setMouseStatus( MOUSE_PICK );
	m_statusBar.SetPaneText(0, "Aktion: Objekt auswhlen | Men: mittlere Maustaste", TRUE);
}

/**
 * Fired when button "Change WC" was clicked.
 */
void Cprakt3Dlg::OnBnClickedButtonChangeWC() {
	m_statusBar.SetPaneText(0, "Weltkoordinaten ndern...", TRUE);

	CDialogChangeWC dlgWindow;
	if ( dlgWindow.DoModal() != IDCANCEL ) {
		m_wOpenGL.OnDrawGL();
	}

	m_statusBar.SetPaneText(0, m_cSBText, TRUE);
}