// prakt3Dlg.h : Headerdatei

#include "myOpenGL.h"
#include "Grafik.h"
#include "afxwin.h"
#include "resource.h"

#include "DialogDrawLine.h"
#include "DialogDrawCircle.h"
#include "DialogDelObject.h"
#include "DialogMoveObject.h"
#include "DialogRotateObject.h"
#include "DialogScaleObject.h"
#include "DialogFlipObject.h"
#include "DialogChangeWC.h"

#pragma once


// Cprakt3Dlg Dialogfeld
class Cprakt3Dlg : public CDialog
{

private:
	Cprakt3Dlg(CWnd* pParent = NULL);	// Standardkonstruktor (private wg. Singleton!)

public:
	static Cprakt3Dlg* getInstance();

	enum { IDD = IDD_PRAKT3_DIALOG };

	static const int CAD_IDLE					=  0;
	static const int CAD_DELETE					=  1;
	static const int CAD_DRAW_LINE_FIRST_POINT	= 10;
	static const int CAD_DRAW_LINE_SECOND_POINT	= 11;
	static const int CAD_DRAW_CIRCLE_CENTER		= 20;
	static const int CAD_DRAW_CIRCLE_PERIPHERAL	= 21;
	static const int CAD_MOVE_PICK				= 30;
	static const int CAD_MOVE_SET_VECTOR		= 31;
	static const int CAD_ROTATE_PICK			= 50;
	static const int CAD_ROTATE_LOC_BASEPOINT	= 51;
	static const int CAD_ROTATE_SET_RADIUS		= 52; 
	static const int CAD_SCALE_PICK				= 60;
	static const int CAD_SCALE_LOC_BASEPOINT	= 61;
	static const int CAD_SCALE_SET_FACTOR		= 62;
	static const int CAD_FLIP_PICK				= 70;
	static const int CAD_FLIP_LOC_STRAIGHT_1ST	= 71;
	static const int CAD_FLIP_LOC_STRAIGHT_2ND	= 72;

private:
	static Cprakt3Dlg *m_pInstance;
	CStatusBar m_statusBar;
	char m_cSBText [200];
	myOpenGL m_wOpenGL;
	CGO_Point m_gPoint;
	int	m_iCadState;

protected:
	HICON m_hIcon;

	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung

	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnPick(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnLocate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMove(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSample(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserInput(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

public:
	myOpenGL* getMyOpenGLWindow();
	int getCadState();

	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedSave();
	afx_msg void OnBnClickedLoad();
	afx_msg void OnBnClickedDrawLine();
	afx_msg void OnBnClickedDrawCircle();
	afx_msg void OnBnClickedDelObject();
	afx_msg void OnBnClickedMoveObject();
	afx_msg void OnBnClickedRotateObject();
	afx_msg void OnBnClickedScaleObject();
	afx_msg void OnBnClickedFlipObject();
	afx_msg void OnBnClickedButtonChangeWC();
};
