#include "StdAfx.h"
#include "grafik.h"

CGrafik::CGrafik(void)
{
	//Initialwerte fuer Verschiebung u. Drehwinkel:
	m_fWinkel	= 30;	//Drehwinkel der Wippe
	m_fWeg		= 45;	//Verschiebung des Schlittens
}

void CGrafik::setWinkel(GLfloat fWinkel) {
    m_fWinkel = fWinkel;
}

void CGrafik::setWeg(GLfloat fWeg) {
    m_fWeg = fWeg;
}

GLfloat CGrafik::getWinkel() {
   return m_fWinkel;
}

GLfloat CGrafik::getWeg() {
   return m_fWeg;
}

CGrafik::~CGrafik(void)
{
}


void CGrafik::Init()
{
listIndex = glGenLists(1);	//1 Displayliste

//Quadrat ([-.5,.5] x [0,1])
glNewList(listIndex, GL_COMPILE);
	glBegin(GL_LINE_LOOP);
		glVertex2f(0,0);
		glVertex2f(1,0);
		glVertex2f(1,1);
		glVertex2f(0,1);
	glEnd();
glEndList();

//Referenzpunkt im Ursprung des lokalen KOS:
glNewList(listIndex + 1, GL_COMPILE);
	glBegin(GL_POINTS);
		glVertex2f(0,0);
	glEnd();
glEndList();

}

void CGrafik::Draw()
{
	glColor3f(0,0,0);
	glLineWidth(1);
	glPointSize(5);

	//Ursprung des Welt-KOS:
	//glColor3f(1,0,0);
	//glCallList(listIndex + 1);
	//glColor3f(0,0,0);

	//Gestell:
	glPushMatrix();
		glScalef(300,60,1);			//Skalierung
		glCallList(listIndex);		//Figur zeichnen
	glPopMatrix();

	//Quadrat auf Gestell:
	glPushMatrix();
		glTranslatef(70,60,0);		//Translation
		glScalef(50,50,1);			//Skalierung
		glCallList(listIndex);		//Figur zeichnen
	glPopMatrix();

	//BEGIN lokales KOS fuer Schlitten:
	glPushMatrix();
		glTranslatef(210 + m_fWeg,60,0);

		//Ursprung des lokalen KOS (Schlitten):
		//glColor3f(0,1,0);
		//glCallList(listIndex + 1);
		//glColor3f(0,0,0);
		
		//Schlitten:
		glPushMatrix();
			glTranslatef(-40,00,0);		//Translation
			glScalef(80,40,1);			//Skalierung
			glCallList(listIndex);		//Figur zeichnen
		glPopMatrix();

		//senkrechter Balken:
		glLineWidth(3);
		glBegin(GL_LINES);
			glVertex2f(0,40);
			glVertex2f(0,190);
		glEnd();
		glLineWidth(1);

		//BEGIN lokales KOS fuer Wippe:
		glPushMatrix();
			glTranslatef(0,190,0);
			glRotatef(m_fWinkel,0,0,1);

			//Ursprung des lokalen KOS (Wippe):
			//glColor3f(0,1,1);
			//glCallList(listIndex + 1);
			//glColor3f(0,0,0);

			//waagerechter Balken:
			glLineWidth(3);
			glBegin(GL_LINES);
				glVertex2f(-60,0);
				glVertex2f(+60,0);
			glEnd();
			glLineWidth(1);

			//rechtes Quadrat:
			glPushMatrix();
				glTranslatef(45,-15,0);		//Translation
				glScalef(30,30,1);			//Skalierung
				glCallList(listIndex);		//Figur zeichnen
			glPopMatrix();

			//linkes Quadrat:
			glPushMatrix();
				glTranslatef(-75,-15,0);	//Translation
				glScalef(30,30,1);			//Skalierung

				glPushMatrix();
					glTranslatef(.5,.5,0);		//Mittelpunkt des Quadrats
					glRotatef(45,0,0,1);		//Drehung um Mittelpunkt
					glTranslatef(-.5,-.5,0);	//Ruecktranslation
					glCallList(listIndex);		//Figur zeichnen
				glPopMatrix();
			glPopMatrix();
	
		glPopMatrix();
		//END lokales KOS fuer Wippe
	
	glPopMatrix();
	//END lokales KOS fuer Schlitten


	//Ausgabe der Grafikobjekte:
	glFlush();	
}
